//---------------------------------------------------------------------------

#include <windows.h>
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be performing new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
    return 1;
}
//---------------------------------------------------------------------------


extern "C" __declspec(dllexport) char init(void);
extern "C" __declspec(dllexport) void eval(void);

extern "C" __declspec(dllexport) int Mode;
extern "C" __declspec(dllexport) float Actual;
extern "C" __declspec(dllexport) float Wished;
extern "C" __declspec(dllexport) float Error;
extern "C" __declspec(dllexport) float Kp;
extern "C" __declspec(dllexport) float Ki;
extern "C" __declspec(dllexport) float Yp;
extern "C" __declspec(dllexport) float Yi;
extern "C" __declspec(dllexport) float Output;



#define MODE_ENABLE         0x01
#define MODE_INIT           0x02

int Mode=0;
float Actual=0;
float Wished=0;
float Error=0;
float Kp=1;
float Ki=0;
float Yp=0;
float Yi=0;
float Output=0;

int DLLHooks=0;


char init(void)
{

    Mode=MODE_ENABLE;
    Actual=0;
    Wished=0;
    Error=0;
    Kp=1;
    Ki=1;
    Yp=0;
    Yi=0;
    Output=0;

    DLLHooks++;
    return DLLHooks;
}


void eval(void)
{
    if(!(Mode & MODE_ENABLE))
        return;

    if(Mode & MODE_INIT)
    {
        init();
        DLLHooks--;
        return;
    }

    Error = Wished - Actual;

    Yp = Kp * Error;
    Yi += Ki * Error;

    Output = Yp + Yi;
}

